import { HttpMethod, Route, StatusCodes } from 'org.crazydoctor.expressts';
import { Request, Response } from 'express';
import ServerApp from '..';

class PostInheritedComments extends Route {
	protected action = (req: Request, res: Response): any => {
		const params = req.body;
		const query = JSON.parse(params.query);

		if(ServerApp.SourcesUpdating) {
			res.status(StatusCodes.CONFLICT).send('Sources are being updated.');
			return;
		}

		const inheritedComments: any = {};
		const querySize = Object.keys(query).length;
		let index = 0;

		for(const className of Object.keys(query)) {
			const props = query[className];
			ServerApp.getDb().all(`SELECT * FROM comments WHERE class = ? AND property IN (${props.map(() => '?').join(', ')})`, [className, ...props], (err, rows) => {
				if(err) {
					res.status(StatusCodes.INTERNAL_SERVER_ERROR).send('Internal server error');
					return;
				}

				const commentsObj: any = {};

				rows.forEach((comment: any) => {
					commentsObj[comment.property] = { comment: comment.comment, timestamp: comment.timestamp };
				});

				inheritedComments[className] = commentsObj;
				index++;
				if(index === querySize)
					res.status(StatusCodes.OK).send(JSON.stringify(inheritedComments));
			});
		}
	};

	protected method = HttpMethod.POST;
	protected order = 8;
	protected route = '/getInheritedComments';
}

export default PostInheritedComments;