import { HttpMethod, Route, StatusCodes } from 'org.crazydoctor.expressts';
import { Request, Response } from 'express';
import { ISession } from '../session/ISession';

class PostLogout extends Route {
	protected action = (req: Request, res: Response): any => {
		const session = req.session as ISession;
		
		session.isAdmin = false;
		res.status(StatusCodes.OK).send('OK');
	};

	protected method = HttpMethod.POST;
	protected order = 4;
	protected route = '/logout';
}

export default PostLogout;